#!/usr/bin/env python

import codecs, sys
import DuckyLib
from DuckyLib import technorati as tec
from DuckyLib.yahoo.search import webservices
from DuckyLib import amazon, feedster, gataga, google, noaa, topix, yahoo, ynews
from pprint import pprint

def info():
    print 'ducky, the web services command line.'
    print 'Copyright (c) 2005 Jose Nazario, all rights reserved.'
    print 'Uses libraries with these copyrights:'
    print 'Technorati support:', tec.__copyright__
    print 'Google support:', google.__copyright__
    print 'Amazon support:', amazon.__copyright__
    print 'Feedster support:', feedster.__copyright__
    print 'Yahoo! support:', yahoo.search.webservices.__copyright__
    print 'Topix support:', topix.__copyright__
    print 'Yahoo! News support:', ynews.__copyright__
    print 'NOAA support:', noaa.__copyright__
    print 'Gataga support:', gataga.__copyright__

def _descape(input):
    """opposite of cgi.escape() ..."""
    input = input.replace('&gt;', '>')
    input = input.replace('&lt;', '<')
    input = input.replace('&quot;', '"')
    input = input.replace('&#39;', """'""")
    input = input.replace('&amp;', '&')
    return input

def setKeys():
    try: amazon.setLicense(amazon.getLicense())
    except: pass
    try: google.setLicense(google.getLicense())
    except: pass
    try: tec.setLicense(tec.findkey())
    except: pass
    try: feedster.setLicense(feedster.getLicense())
    except: pass

def doYNews(terms):
    """get Yahoo! news results via RSS
       keys are: [u'title', u'source', u'link', u'description', u'pubDate']"""
    results = ynews.search('+'.join(terms))[1:9] # skip header, footer
    i = 1
    for r in results:
        print '\n%d. %s' % (i, r[u'title']),
        try: print ' (%s)' % r['source'],
        except: pass
        print '\n   %s' % r[u'description']
        print '   %s' % r[u'pubDate']
        print '   %s' % r[u'link']
        i = i + 1
    sys.exit(0)

def doNoaa(site):
    """get NOAA weather results from an airport"""
    results = noaa.search(site)
    for r in results:
	print 'Current conditions:\n%s' % r[u'title']
	print '%s' % r[u'description']
	print '%s' % r[u'link']
    sys.exit(0)

def doTopix(terms):
    """get topix results via RSS
       keys are: [u'title', u'source', u'link', u'description', u'pubDate']"""
    results = topix.search('+'.join(terms))[1:9] # skip header, footer
    i = 1
    for r in results:
        print '\n%d. %s' % (i, r[u'title']),
        try: print ' (%s)' % r['source'],
        except: pass
        print '\n   %s' % r[u'description']
        print '   %s' % r[u'pubDate']
        print '   %s' % r[u'link']
        i = i + 1
    sys.exit(0)

def doAmazon(type, terms):
    """wrap the amazon search interface"""
    try: 
        if type == 'keyword': books = amazon.searchByKeyword('%s' % ' '.join(terms))
        elif type == 'asin': books = amazon.searchByASIN('%s' % ' '.join(terms))
    except:
        print "An error occured."
        sys.exit(-1)
    for b in books: 
        print '\n%s: %s  ' % (b.Catalog, b.ProductName),
        try: print 'Price: %s' % b.OurPrice,
        except: pass
        try: 
            author = b.Authors.Author
            if len(author) < 5: print '\nAuthors: %s' % ', '.join(author),
            else: print '\nAuthor: %s' % author,
        except: pass
        print '\n%s' % b.URL
    sys.exit(0)

def doTec(terms):
    """wrap the technorati search interface"""
    try: data = tec.search('%s' % ' '.join(terms))
    except:
        print "An error occured."
        sys.exit(-1)
    i = 1
    for r in data['search']:
        r['excerpt'] = r['excerpt'].replace('<strong class="keyword">', '')
        r['excerpt'] = r['excerpt'].replace('</strong>', '')
        blog = r['weblog']
        try:
            print '\n%d. %s' % (i, blog['name'].encode('utf-8'))
            print '     %s' % r['excerpt'].encode('utf-8')
            print u'     %s' % blog['url']
            print u'     %s' % blog['lastupdate']
        except: pass
        i = i + 1
    sys.exit(0)

def doTag(terms):
    """wrap the gataga search engine"""
    """[u'dc:date', u'dc:creator', u'link', u'description', u'title']"""
    try: results = gataga.search('%s' % '%20'.join(terms))
    except:
        print "An error occured."
        sys.exit(-1)
    i = 1
    for r in results:
        print '\n%d. %s' % (i, r[u'title']),
        try: print ' (%s)' % r['dc:creator'],
        except: pass
        print '\n   %s' % r[u'dc:date']
        print '   %s' % r[u'link']
        i = i + 1
    sys.exit(0)

def doFeed(terms):
    """wrap the feedster search engine ..."""
    results = feedster.search('%s' % '+'.join(terms))
    i = 1
    for r in results:
        print '\n%d. %s' % (i, r[u'title'].strip()),
        try: print ' (%s)' % r['source'].strip(),
        except: pass
        print '\n   %s' % r[u'pubDate'].strip()
        print '   %s' % r[u'link'].strip()
        i = i + 1
    sys.exit(0)

def doYahoo(terms):
    """wrap the Yahoo! WS search ..."""
    x = webservices.create_search("web", "YahooDemo", query=' '.join(terms), results=10)
    srch = x.parse_results()
    i = 1
    for s in srch._get_results():
       print '\n%d. %s' % (i, s['Title'])
       print '   %s' % s['Summary']
       print '   %s' % s['Url']
       i = i + 1
    sys.exit(0)

def doGoogle(terms):
    """wrap the google search interface"""
    try: data = google.doGoogleSearch('%s' % ' '.join(terms))
    except:
        print "An error occured."
        sys.exit(-1)
    print 'Results 1 - 10 of about %s for %s' % \
        (str(data.meta.estimatedTotalResultsCount), ' '.join(terms))
    i = 1
    for r in data.results: 
       title = r.title
       title = title.replace('<b>', '')
       title = title.replace('</b>', '')
       snippet = r.snippet
       snippet = snippet.replace('<b>', '')
       snippet = snippet.replace('</b>', '')
       snippet = snippet.replace('<br>', '')
       url = r.URL
       url = url.replace('<b>', '')
       url = url.replace('</b>', '')
       print u'%d. %s' % (i, title)
       print u'     %s' % _descape(snippet)
       print u'     %s\n' % url
       i = i + 1
    sys.exit(0)

def main():
    setKeys()
    sys.stdout = codecs.lookup('utf-8')[-1](sys.stdout)

    argv0 = sys.argv[0].replace('./', '')

    if argv0.rfind('am', 0, 2) > -1:
        doAmazon('keyword', sys.argv[1:])
    elif argv0.rfind('g', 0, 1) > -1:
        doGoogle(sys.argv[1:])
    elif argv0.rfind('ya', 0, 2) > -1:
        doYahoo(sys.argv[1:])
    elif argv0.rfind('amuk', 0, 4) > -1:
        amazon.setLocale('uk')
        doAmazon(sys.argv[1:])
    elif argv0.rfind('ameu', 0, 4) > -1:
        amazon.setLocale('eu')
        doAmazon(sys.argv[1:])
    elif argv0.rfind('amjp', 0, 4) > -1:
        amazon.setLocale('jp')
        doAmazon(sys.argv[1:])
    elif argv0.rfind('tec', 0, 3) > -1:
        doTec(sys.argv[1:])
    elif argv0.rfind('tag', 0, 3) > -1:
        doTag(sys.argv[1:])
    elif argv0.rfind('feed', 0, 4) > -1:
        doFeed(sys.argv[1:])
    elif argv0.rfind('asin', 0, 4) > -1:
        doAmazon('asin', sys.argv[1:])
    elif argv0.rfind('noaa', 0, 5) > -1:
        doNoaa(sys.argv[1].upper())
    elif argv0.rfind('topix', 0, 5) > -1:
        doTopix(sys.argv[1:])
    elif argv0.rfind('ynews', 0, 5) > -1:
        doYNews(sys.argv[1:])
    else:
        info()

if __name__ == '__main__':
    main()
